#include "RSAPrivateKey.h"
#include "ber_decoder.h"

int main(int argc, char **argv)
{

	if (argc != 2) {
		printf("One parameter required - RSAPRIVKEY filename.\n");
		return 123;
	}

	RSAPrivateKey_t *privKey;
	privKey = (RSAPrivateKey_t*)calloc(1, sizeof *privKey);
	if(!privKey) exit(1);

	// load file
	FILE *f=fopen(argv[1],"rb");
	if(!f) { printf("File not found\n"); exit(133);}
	unsigned char buffer[90000];
	int bufflen;
	bufflen=fread(buffer,1,90000,f);
	fclose(f);

	// load key to internal structure
	asn_dec_rval_t rval = ber_decode(
		0,
		&asn_DEF_RSAPrivateKey,
		(void**)&privKey,
		buffer,
		bufflen
	);

	if(rval.code == RC_WMORE) { printf("rc_wmore.\n");}
	if(rval.code == RC_FAIL) { printf("rc_fail.\n");}


	// since this uses its own integer implementation, we need
	// to conver it to something useful and print it
	long dd = 0;
	asn_INTEGER2long(&privKey->publicExponent, &dd);
	printf("Public exponent: %ld\n", dd);


	
	return 0;
}
